%global meadalpha %{nil}
%global meadrel %{nil}
%{?scl:%scl_package openssl-pkcs11}
%{!?scl:%global pkg_name %{name}}

%global version_major 0
%global version_minor 4
%global version_micro 10
%global commitid 2a908f06aa8b147fb5b905d5282151f782cb2aa9
%global serial 22
# Define the directory where the OpenSSL engines are installed
%global enginesdir %{_libdir}/openssl/engines-1.1

Name:           %{?scl_prefix}openssl-pkcs11
Summary:        A PKCS#11 engine for use with OpenSSL
Version: 0.4.10
Release: %{serial}%{?dist}
# The source code is LGPLv2+ except eng_back.c and eng_parse.c which are BSD
License:        LGPLv2+ and BSD
URL:            https://github.com/OpenSC/libp11
Source:        openssl-pkcs11-%{commitid}.tar.gz
BuildRequires:  autoconf automake libtool
BuildRequires:  jbcs-httpd24-openssl-devel
BuildRequires:  jbcs-httpd24-openssl >= 1.0.2
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(p11-kit-1)
# Needed for testsuite
BuildRequires:  softhsm opensc procps-ng
Requires:       p11-kit-trust
Requires:       jbcs-httpd24-openssl >= 1.0.2
Provides:       libp11%{?_isa} = %{version}-%{release}
Obsoletes:      libp11 < 0.4.7-4
# The engine_pkcs11 subpackage is also provided 
Provides:       jbcs-httpd24-engine_pkcs11%{?_isa} = %{version}-%{release}
Obsoletes:      jbcs-httpd24-engine_pkcs11 < 0.4.7-4

%description -n %{?scl_prefix}openssl-pkcs11
openssl-pkcs11 enables hardware security module (HSM), and smart card support in
OpenSSL applications. More precisely, it is an OpenSSL engine which makes
registered PKCS#11 modules available for OpenSSL applications. The engine is
optional and can be loaded by configuration file, command line or through the
OpenSSL ENGINE API.


%prep
#%autosetup -p 1 -n openssl-pkcs11-%{commitid}

%build
autoreconf -fvi
export CFLAGS="%{optflags}"
%if 0%{?fedora}
%configure --disable-static --enable-api-doc --with-enginesdir=%{enginesdir}
%else
%configure --disable-static --with-enginesdir=%{enginesdir}
%endif
make V=1 %{?_smp_mflags}

%install
mkdir -p %{buildroot}%{enginesdir}
make install DESTDIR=%{buildroot}

# Remove libtool .la files
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{enginesdir}/*.la

%if ! 0%{?fedora}
## Remove development files
rm -f %{buildroot}%{_libdir}/libp11.so
rm -f %{buildroot}%{_libdir}/pkgconfig/libp11.pc
rm -f %{buildroot}%{_includedir}/*.h
%endif

# Remove documentation automatically installed by make install
rm -rf %{buildroot}%{_docdir}/libp11/

%check
#make check %{?_smp_mflags} || if [ $? -ne 0 ]; then cat tests/*.log; exit 1; fi;

#%ldconfig_scriptlets

%files
%license COPYING
%doc NEWS
%{_libdir}/libp11.so.*
%{enginesdir}/*.so

%changelog
* Wed Sep 15 2021 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-22
Built by CPaaS

* Wed Sep 15 2021 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-21
Built by CPaaS

* Thu Apr 01 2021 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-20
Built by CPaaS

* Fri Mar 26 2021 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-19
Built by CPaaS

* Mon Dec 21 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-18
Built by CPaaS

* Wed Dec 09 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-17
Built by CPaaS

* Tue Dec 08 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-16
Built by CPaaS

* Tue Dec 08 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-15
Built by CPaaS

* Sun Oct 11 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-14
Built by CPaaS

* Sat Oct 10 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-13
Built by CPaaS

* Thu Oct 08 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-12
Built by CPaaS

* Tue Oct 06 2020 cpaas-ops <cpaas-ops@redhat.com> - 0.4.10-11
Built by CPaaS

* Thu Nov 28 2019 Anderson Sasaki <ansasaki@redhat.com> - 0.4.10-2
- Set RSA_FLAG_FIPS_METHOD for RSA methods (#1777892)

* Thu Nov 21 2019 Anderson Sasaki <ansasaki@redhat.com> - 0.4.10-1
- Update to 0.4.10 (#1745082)
- Add BuildRequires for OpenSSL >= 1.0.2, required for testing
- Print tests logs if failed during build
- Small bug fixes such as removal of unused variable
- Search objects in all matching tokens (#1705505)

* Tue Sep 18 2018 Anderson Sasaki <ansasaki@redhat.com> - 0.4.8-2
- Require OpenSSL >= 1.0.2
- Fixed missing declaration of ERR_get_CKR_code()
- Add support to use EC keys and tests (#1625338)
- Exposed check_fork() API
- Fixed memory leak of RSA objects in pkcs11_store_key()
- Updated OpenSSL license in eng_front.c
- Fixed build for old C dialects
- Allow engine to use private key without PIN
- Require DEBUG to be defined to print debug messages
- Changed package description

* Mon Aug 06 2018 Anderson Sasaki <ansasaki@redhat.com> - 0.4.8-1
- Update to 0.4.8-1
- RSA key generation on the token
- RSA-OAEP and RSA-PKCS encryption support
- RSA-PSS signature support
- Support for OpenSSL 1.1.1 beta
- Removed support for OpenSSL 0.9.8
- Various bug fixes and enhancements

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.7-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Jun 06 2018 Anderson Sasaki <ansasaki@redhat.com> - 0.4.7-7
- Reintroduce libp11-devel subpackage to Fedora (#1583719)

* Tue Mar 13 2018 Anderson Sasaki <ansasaki@redhat.com> - 0.4.7-6
- Obsolete libp11-devel to fix update

* Tue Mar 06 2018 Anderson Sasaki <ansasaki@redhat.com> - 0.4.7-5
- Fixed broken Obsoletes

* Thu Mar 01 2018 Anderson Sasaki <ansasaki@redhat.com> - 0.4.7-4
- Package renamed from libp11 to openssl-pkcs11
